<?php

function rv_mt_get_categories_menu_sql_where($where, $expand, $filter)
{
	add_event_handler('get_html_menu_category', 'rv_mt_get_html_menu_category', EVENT_HANDLER_PRIORITY_NEUTRAL, 3);

	if ($expand)
		return $where;
	if ($filter)
	{
		global $rv_mt_all_open;
		$rv_mt_all_open = true;
		return $where;
	}

	global $page;
	if ( !isset($page['category']) )
		$where = 'id_uppercat IS NULL OR uppercats REGEXP \'^[0-9]+,[0-9]+$\'';
	else
	{
	  $where = 'id_uppercat is NULL
	OR uppercats LIKE "'.$page['category']['upper_names'][0]['id'].',%"
	OR uppercats REGEXP \'^[0-9]+,[0-9]+$\'';
	}
	return $where;
}


function rv_mt_get_html_menu_category($menu, $categories, $selected_category)
{
	global $lang;

	$ref_level = 0;
	$level = 0;
	$menu = '';

	$upper_ids=array();
	if ( null!=$selected_category)
		$upper_ids = array_flip( explode(',', $selected_category['uppercats']) );

	foreach ($categories as $category)
	{
		$level = substr_count($category['global_rank'], '.') + 1;
		if ($level > $ref_level)
		{
			if ($ref_level==0)
				$menu.= "\n<ul class=\"rvTree\" id=\"theCategoryMenu\">";
			else
				$menu.= "\n<ul>";
		}
		elseif ($level == $ref_level)
			$menu.= "</li>";
		elseif ($level < $ref_level)
		{
			// we may have to close more than one level at the same time...
			$menu.= "</li>";
			$menu.= str_repeat("\n</ul></li>",($ref_level-$level));
		}
		$ref_level = $level;

		$menu.= "\n".'<li';
		$class_names = array();
		if ($category['id'] == @$selected_category['id'])
			array_push( $class_names, 'selected');
		global $rv_mt_all_open;

		if ($category['count_categories']>0)
		{
			if ( isset($rv_mt_all_open) and $rv_mt_all_open )
				array_push( $class_names, 'liOpen');
			elseif ( isset( $upper_ids[ $category['id'] ] ) )
			{
				array_push( $class_names, 'liOpen');
				unset($upper_ids[ $category['id'] ] );
			}
			else
				array_push( $class_names, 'liClosed');
		}

		if (count($class_names))
			$menu.= ' class="'.implode($class_names,' ').'"';
		$menu.= '>';

		$url = make_index_url( array( 'category' => $category ) );

		$title = get_display_images_count(
							$category['nb_images'], $category['count_images'], $category['count_categories'],
							false,
							' / '
						);

		$menu.= '<a href="'.$url.'"';
		if ($selected_category!=null and $category['id'] == $selected_category['id_uppercat'])
			$menu.= ' rel="up"';
		$menu.= ' title="'.$title.'">'.$category['name'].'</a>';

		if ( $category['count_images']>0 )
		{// at least one direct or indirect image
			$menu.= '<span class="';
			// at least one image in this category -> class menuInfoCat
			$menu.= ($category['nb_images'] > 0 ? "menuInfoCat" : "menuInfoCatByChild").'"';
			$menu.= ' title=" '.$title.'">';
			// show total number of images
			$menu.= ' ['.$category['count_images'].']';
			$menu.= '</span>';
		}
		$child_date_last = @$category['max_date_last']> @$category['date_last'];
		$menu.= get_icon($category['max_date_last'], $child_date_last);
	}

	$menu.= str_repeat("\n</li></ul>",($level));
	$menu.= '<script type="text/javascript">RVTree.convertTree( document.getElementById("theCategoryMenu") );</script>';

	//$head = '<link rel="stylesheet" type="text/css" media="screen,print" href="'.get_root_url().'plugins/'. basename(dirname(__FILE__)).'/rvtree-min.css">'."\n";

	$dirname = dirname(__FILE__);
	$head = '<style type="text/css">'. str_replace( 'url(', 'url('.get_root_url().'plugins/'.basename($dirname).'/',file_get_contents($dirname.'/rvtree-min.css'))."</style>\n";

	$head .= '<script type="text/javascript" src="'.get_root_url().'plugins/'. basename(dirname(__FILE__)).'/rvtree-min.js"></script>';

	global $template;
	$template->append( 'head_elements', $head);
	return $menu;
}

?>